from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="LiveTVApiListingProviderTypeInfo")


@attr.s(auto_attribs=True)
class LiveTVApiListingProviderTypeInfo:
    """
    Attributes:
        name (Union[Unset, str]):
        id (Union[Unset, str]):
        setup_url (Union[Unset, str]):
    """

    name: Union[Unset, str] = UNSET
    id: Union[Unset, str] = UNSET
    setup_url: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        name = self.name
        id = self.id
        setup_url = self.setup_url

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if name is not UNSET:
            field_dict["Name"] = name
        if id is not UNSET:
            field_dict["Id"] = id
        if setup_url is not UNSET:
            field_dict["SetupUrl"] = setup_url

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        name = d.pop("Name", UNSET)

        id = d.pop("Id", UNSET)

        setup_url = d.pop("SetupUrl", UNSET)

        live_tv_api_listing_provider_type_info = cls(
            name=name,
            id=id,
            setup_url=setup_url,
        )

        live_tv_api_listing_provider_type_info.additional_properties = d
        return live_tv_api_listing_provider_type_info

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
